import Foundation

struct MyStruct {
  let a: MyClass = MyClass()
  let b: MyClass = MyClass()
}

class MyClass {
  let a: Int = 1
  let b: Int = 2

  init() {}
}

dynamic func noop(_ x: MyStruct) -> MyStruct { return x }
dynamic func noop(_ x: MyClass) -> MyClass { return x }

func performanceTest() {
  var value = MyClass()
  let repetitions = 1000000
  let start = Date()
  for _ in 0..<repetitions {
    value = noop(value)
  }
  let end = Date()
  print("\(end.timeIntervalSince(start))s total")
  print("\(end.timeIntervalSince(start) * 1_000_000_000 / Double(repetitions))ns / function call")
}

performanceTest()

// - Show cost of passing struct around
// - Show cost of passing class around
// - Enable breakpoints and show that retain is being executed
